/*
 * Brightness Tracking 
 * by Golan Levin. 
 *
 * Tracks the brightest pixel in a live video signal. 
 */

Movie myMovie;
import processing.video.*;
import ddf.minim.*;
import gifAnimation.*;

//Minim minim;

AudioPlayer in;
AudioPlayer out;
AudioPlayer all;
AudioPlayer burning;

//PImage[] myAnimation;
Gif myAnimation;
int x = 0;
int y = 2;
Minim minim1;
Minim minim2;
Minim minim3;
Minim minim4;
Capture video;

void setup() {
  size(640, 480);
  // Uses the default video input, see the reference if this causes an error
  video = new Capture(this, width, height);
  video.start();  
  noStroke();
  smooth();
  // myMovie = new Movie(this, "flame.mov");
  // myMovie.loop();
  minim1 = new Minim(this);
  minim2 = new Minim(this);
  minim3 = new Minim(this);
  minim4 = new Minim(this);

  in = minim1.loadFile("Ignition.mp3", 2048);
  out = minim2.loadFile("Snuff.mp3", 2048);
  all = minim3.loadFile("Zen Dojo ATK.mp3", 2048);
  burning = minim3.loadFile("Burning.mp3", 2048);
  imageMode(CENTER);
  // textFont(createFont("Arial", 12));

  myAnimation = new Gif(this, "flame.gif");
  myAnimation.loop();
  all.loop();
  burning.loop();
}
/*
void movieEvent(Movie m) {
 m.read();
 }
 */
void draw() {
burning.setGain(0);


  if (video.available()) {
    video.read();
    image(video, 320, 240, width, height); // Draw the webcam video onto the screen
    int brightestX = 0; // X-coordinate of the brightest video pixel
    int brightestY = 0; // Y-coordinate of the brightest video pixel
    float brightestValue = 0; // Brightness of the brightest video pixel
    // Search for the brightest pixel: For each row of pixels in the video image and
    // for each pixel in the yth row, compute each pixel's index in the video
    video.loadPixels();
    int index = 0;
    for (int y = 0; y < video.height; y++) {
      for (int x = 0; x < video.width; x++) {
        // Get the color stored in the pixel
        int pixelValue = video.pixels[index];
        // Determine the brightness of the pixel
        float pixelBrightness = brightness(pixelValue);
        // If that value is brighter than any previous, then store the
        // brightness of that pixel, as well as its (x,y) location
        if (pixelBrightness > brightestValue) {
          brightestValue = pixelBrightness;
          brightestY = y;
          brightestX = x;
        }
        index++;
      }
    }


    if (brightestValue > 200) {

      image(myAnimation, brightestX, brightestY);
      in.play();
      //burning.setVolume(1);
    
      y = 0;
      out.pause();
      out.cue(0);
      all.pause();
      //x++;

      //image(myMovie, brightestX, brightestY);
    }
    /*
    if (x > 1) {
     //in.play();
     }
     */
    if (brightestValue < 200) {
      x = 0;
     // burning.setVolume(0);
      //burning.pause();
      burning.setGain(-80);
      out.play();
      in.pause();
      in.cue(0);
      all.play();
      //y++;
    }
    /*
    if (y > 0) {
     out.play();
     }
     */
    println(x);
  }
}

